'==================================================================
'				This script was created by eXeDK (TJ110000)
'				Free use but do give me a little credit :)
'				Contact: http://www.e-x-e.dk/ or laptop@e-x-e.dk
'==================================================================
'				The variables for the code is below
'==================================================================
'You enable and disable functions by changing the True or False values after every equal-sign.

ShowTopText = True
AddExtraLine = True 'This will add an extra free line under the ShowTopText - only works if ShopTopText in set as Tru

ShowItemType = True

ShowSubFolders = True
	ShowSubFoldersFiles = False
	ShowEachFolderSize = False
	ShowEachFileSize = False

ShowFiles = True
ShowFileType = True

ShowRootFolderSize = False
ShowRootFolderStatistics = False

'==================================================================
'				The code is below
'==================================================================

Function FolderPathCheck(FolderPath)
	If Right(FolderPath, 1) = "\" Then
		FolderPathCheck = FolderPath
	Else
		path = FolderPath & "\"
	End if
FolderPathCheck = path
End Function

Function FolderEmpty(Path, TheType)
    ' Check for an empty folder.
    Dim fso, oFolder, oFiles         ' Object variables
    Dim i, flag
	
	If TheType = "SubFolders" Then
	    Set fso = CreateObject("Scripting.FileSystemObject")
		Set oFolder = fso.GetFolder(path)   
		Set oFiles = oFolder.SubFolders         

		flag = True                         
		For Each i in oFiles                
			flag = False                    
			Exit For
		Next
	ElseIf TheType = "Files" Then
		Set fso = CreateObject("Scripting.FileSystemObject")
		Set oFolder = fso.GetFolder(path)   
		Set oFiles = oFolder.Files          

		flag = True                         
		For Each i in oFiles                
			flag = False	                
			Exit For
		Next
	End if

    FolderEmpty = flag                  
End Function


Function AdvandedDirList(FolderPath)
FolderPath = FolderPathCheck(FolderPath)
	numbFolders = "0"
	numbFiles = "0"
	Set fso = CreateObject("Scripting.FileSystemObject")
	If (fso.FolderExists(FolderPath)) Then
		Set fl = fso.GetFolder(FolderPath)
		If ShowTopText = True Then
			result = result & "Content of """ & fl.Name & """%b"
			If AddExtraLine = True Then
				result = result & "%b"
			End if
		End if
		If ShowSubFolders = True Then
			If ShowItemType = True Then
				result = result & "Folders:%b"
			End if
	If FolderEmpty(FolderPath, "SubFolders") = False Then
			Set ff = fl.SubFolders
			For Each t in ff
				result = result & "%tab" & t.name
				If ShowEachFolderSize = True Then
					result = result & "  -  " & Round(t.size/1024, 2) & " kB"
				End if
				result = result & "%b"
				If ShowSubFoldersFiles = True Then
					Set fso = CreateObject("Scripting.FileSystemObject")
					Set f1 = fso.GetFolder(FolderPath & t.name)
					Set fc = f1.Files
					For Each file in fc
						result = result & "%tab %tab" & file.name
						If ShowEachFileSize = True Then
							result = result & "  -  " & Round(file.size/1024, 2) & " kB"
						End if
						If ShowFileType = True Then
							result = result & "  -  " & file.type
						End if
						result = result & "%b"
						numbFiles = numbFiles+1
					Next
				result = result & "%b"
				End if
			numbFolders = numbFolders+1
			Next
	Else
	result = result & "%tab No folders present%b"
	End if
	End if
	If ShowFiles = True Then
		result = result & "%b"
		If ShowItemType = True Then
			result = result & "Files:%b"
		End if
	If FolderEmpty(FolderPath, "Files") = False Then
		Set files = fl.Files
			For Each file in files
					result = result & "%tab" & file.name
					If ShowEachFileSize = True Then
						result = result & "  -  " & Round(file.size/1024, 2) & " kB"
					End if
					If ShowFileType = True Then
						result = result & "  -  " & file.type
					End if
					result = result & "%b"
			numbFiles = numbFiles+1 
			Next
	Else
		result = result & "%tab No files present%b"
	End if
	End if

	If ShowRootFolderSize = True OR ShowRootFolderStatistics = True Then
		result = result & "%b Root folder specifications:%b"
		If ShowRootFolderSize = True Then
			result = result & "%tab Size: " & Round(fl.size/1024, 2) & " kB %b"
		End if
		If ShowRootFolderStatistics = True Then
			result = result & "%tab Number of folders: " & numbFolders & "%b"
			result = result & "%tab Number of files: " & numbFiles & "%b"
		End if
	End if
Else
result = "Path does not exsist"
End If
'Outputting the result variable as the funtion result
AdvandedDirList = result
End Function
